-- Various functions overridden to run on the main thread.
-- If this is not done, most of these functions will simply
-- not work at all from a Thread.

local http_request = http.request
http.request = function(url, success, fail, parameters)
    Thread.runMain(http_request, url, success, fail, parameters)
end

http.requestSync = function(url, parameters)
    
    local result = nil
    local sem = Semaphore()
    
    Thread.runMain(http_request, url,
        function(response, status, headers) -- Success
            result = { response, status, headers }
            sem:signal()
        end,
        function(err) -- Fail
            result = { nil, err }
            sem:signal()
        end, parameters)
    
    sem:wait()
    
    return table.unpack(result)
end

local viewer_snapshot = viewer.snapshot
viewer.snapshot = function()
    return Thread.runMain(viewer_snapshot)
end
